#region Copyright Syncfusion Inc. 2001 - 2013
// Copyright Syncfusion Inc. 2001 - 2013. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System.Data.SqlServerCe;
using AvoidSelectionInGrouping;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Utility;
using System.Windows.Input;
using Syncfusion.Data;


namespace AvoidSelectionInGrouping
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
           this.sfgrid.RowGenerator = new CustomRowGenerator(this.sfgrid);
        }

    }

    public class CustomRowGenerator : RowGenerator
    {
        public CustomRowGenerator(SfDataGrid dataGrid)
            : base(dataGrid)
        {
        }

        protected override VirtualizingCellsControl GetVirtualizingCellsControl<T>()
        {
            if (typeof(T) == typeof(CaptionSummaryRowControl))
            {
                CustomCaptionSummaryRowControl rowcontrol = new CustomCaptionSummaryRowControl();
                rowcontrol.sfDataGrid = this.Owner;
                return rowcontrol;
            }
            return base.GetVirtualizingCellsControl<T>();
        }
    }

    public class CustomCaptionSummaryRowControl : CaptionSummaryRowControl
    {
        public SfDataGrid sfDataGrid;

        public CustomCaptionSummaryRowControl()
            : base()
        {
            this.DefaultStyleKey = typeof(CustomCaptionSummaryRowControl);
        }

        protected override void OnPreviewMouseLeftButtonUp(MouseButtonEventArgs e)
        {
            var visualContainer = sfDataGrid.GetVisualContainer() as VisualContainer;
            var index = visualContainer.PointToCellRowColumnIndex(e.GetPosition(null));
            if (e.ClickCount == 1 && index.ColumnIndex != 0)
                return;
            base.OnPreviewMouseLeftButtonUp(e);
        }
        protected override void OnPreviewMouseDoubleClick(MouseButtonEventArgs e)
        {
            if (this.DataContext is Group)
            {
                var group = this.DataContext as Group;
                if (group.IsExpanded)
                    sfDataGrid.CollapseGroup(group);
                else
                    sfDataGrid.ExpandGroup(group);
            }
            base.OnPreviewMouseDoubleClick(e);
        }
    }
}
